/*
		bf`ʋKit@C͊֐Q

				Copyright T.Kobayashi
*/

#ifndef TRUE
#define FALSE	0
#define TRUE	(!FALSE)
#endif

#ifdef FLOAT
#define Float float
#else
#define Float double
#endif

#ifdef WINDOWS
	#define MESSAGE
#endif
#ifdef MESSAGE
	#define fprintf crtprintf
	int     crtprintf(FILE * fp, const char * format, ...);
#endif

#if defined(X68000)
	#define	HUGE
	#define	FAR
	#define	nomalize_pointer( p )
	#ifdef	GCC
		#define	REGISTER
		#ifdef __HAVE68881__
			#include <math_68881.h>
		#endif
	#else
		#define	REGISTER	register
	#endif
	#define tempfile temp_file
#elif defined(DJ) || defined(UNIX) || defined(__WIN32__)
	#undef HUGE
	#define	HUGE
	#define	FAR
	#define	nomalize_pointer( p )
	#define	REGISTER
#elif defined(MSC)
	#include <dos.h>
	#define	HUGE	huge
	#define	FAR		far
	#define	nomalize_pointer( p ) {	FP_SEG( p ) += FP_OFF( p ) >> 4 ;\
									FP_OFF( p ) = FP_OFF( p ) & 15 ; }
	#define	REGISTER
	#define interrupt interrupt_func
#elif defined(__BORLANDC__)
	#include <dos.h>
	#define	HUGE	huge
	#define	FAR		far
	#define nomalize_pointer( p ) {p = (void far *)((char huge *)p + 0);}
	#define	REGISTER
	#define interrupt interrupt_func
#else
#error "MACHINE TYPE UNKNOWN!!"
#endif

#ifndef	GCC
	#define	volatile
	#define	const
	#define	inline
#endif

#ifdef VIRTUAL
#ifdef EMS
	#include "..\ems\ems.h"
#endif
	typedef	unsigned long	Pointer ;
#define	dataalloc( size )			( virtualmode ? viralloc( size ) :\
														(Pointer)memalloc( size ) )
#define	dataaryalloc( count, size )	( virtualmode ? viraryalloc( count, size ) :\
														(Pointer)memaryalloc( count, size ) )
#define	datamark()					( virtualmode ? virmark() : (Pointer)memmark() )
#define	datarelease( mark )			{										\
											if ( virtualmode )					\
												virrelease( mark );				\
											else								\
												memrelease( (char*)mark );		\
										}
#define	datasize()					( virtualmode ? virsize() : memsize() )
#define	datacheck					vircheck
#define	pointer( vp )				( virtualmode ? virpointer( vp ) : (void*)(vp) )
#define	datalock()					( virtualmode ? virlock() : 0 )
#define	dataunlock( a ) 			{ if ( virtualmode ) virunlock( a ); }
#define Pointer(type)				Pointer
#else
/*	typedef	char			*Pointer ;*/
#ifdef X68000
#define	dataalloc		memalloc
#else
#include <assert.h>
#define dataalloc(size) (assert((size)>0),assert(((size)%2)==0), memalloc(size))
#endif
#define	dataaryalloc	memaryalloc
#define	datamark		memmark
#define	datarelease		memrelease
#define	datasize		memsize
#define	datacheck		memcheck
#define	pointer(p)		(p)
#define	datalock()		(-1)
#define	dataunlock( a )
#define Pointer(type)				type
#endif

#define MAXWORD			32		/*	P[h̍ŒLN^	*/
#ifndef UNIX
# define F_NAME_LEN		256		/*	t@C̒			*/
#else
# include <stdio.h>
# define F_NAME_LEN	FILENAME_MAX
#endif
#define MAX_FILE		64		/*	t@C̍ől			*/
#define	COLOR_SHIFT		15		/*  F̃Vtg			*/
#define	COLOR_POINT		32768L	/*  F̏_ʒu			*/

#define MAXGRAD			20		/*	Of[Vf[^̍ő	*/
#if defined(MSC) || (!defined(__WIN32__) && defined(__BORLANDC__))
#define MAXLIGHT		32		/*	̐̍ő				*/
#else
#define MAXLIGHT		1024		/*	̐̍ő				*/
#endif

#define	ALLOC_TYPE_DATA	0
#define	ALLOC_TYPE_TEMP	1


/*	v~eBũ^Cv  */
#define POLY			0		/*	rbgOFVFfBO		*/
#define SHADE			1		/*	rbgPFtuW			*/
#define UVPOLY			2
#define UVSHADE			3

/*	}bsÕ^Cv	*/
#define NO_MAP			0		/*	}bsOȂ		*/
#define COLOR_MAP		1		/*	J[}bsO	*/
#define BUMP_MAP		2		/*	ov}bsO	*/

/*	̃^Cv  */
#define LIGHT_POINT		0		/*	_			*/
#define LIGHT_PAL		1		/*	s		*/
#define LIGHT_SPOT		2		/*	X|bgCg	*/
#define LIGHT_OBJ		3		/*				*/

/*	^̒`  */
typedef Float			Matrix[4][4] ;	/*	s				*/
typedef Float			Vector[3] ;		/*	xNg			*/
typedef Float			Point[3] ;		/*	W				*/
typedef long			Color[3] ;		/*	F ( R,G,B )		*/


/*	\̂̒`  */

/*	Agr[g	*/
typedef struct	_Atr{
		char		name[MAXWORD] ;			/*	Agr[g			*/
		Color		col ;					/*	F							*/
		Color		amb, dif, spc, size ;	/*	Agr[g̃p[^	*/
		Color		ref, tra, rfr, att ;	/*	  iʋKiQƁj			*/
		long		h ;						/*	XyL[̐F			*/
		int			rgbflag ;				/*  p[^tO			*/
		int			maptype ;				/*	}bsÕ^Cv			*/
		char		filename[F_NAME_LEN] ;	/*	}bsỎ摜t@C*/
		Float		mapwind[2][2] ;			/*	}bsOp[^		*/
		Float		mapview[2][2] ;
		Float		mapsize[2][2] ;
		Pointer(struct _Atr *)		next ;					/*	ւ̃|C^				*/
	}
		Atr ;

typedef char	AtrName[MAXWORD] ;

/*	v~eBu  */
typedef struct	_Poly {
		int				type ;		/*	v~eBũ^Cv	*/
		Pointer(Atr*)	atr ;		/*	Agr[g			*/
		int				atrid ;		/*	Agr[gԍ		*/
		int				pointnum ;	/*	_					*/
		Pointer(Point*)	 point ;		/*	_Wz			*/
		Pointer(Vector*) vec ;		/*	@xNgz		*/
		Pointer(Vector*) uv ;		/*	tuWz			*/
		Float			coe[4] ;	/*	ʕ̌W		*/
		Pointer(struct _Poly*)			next ;		/*	ւ̃|C^			*/
	}
		Poly ;

/*	IuWFNg  */
typedef struct	_Object {
		char		name[MAXWORD] ;		/*	IuWFNg		*/
		int			atrnum ;			/*	Agr[g	*/
		Pointer(AtrName*)		atrname ;			/*	Agr[g	*/
		int			polynum ;			/*	|S			*/
		Pointer(Poly*)		poly ;				/*	|Sz		*/
		Point		max, min ;			/*	Wől			*/
		Pointer(struct _ObjPos*)		objpos ;			/*	Qƌ`󃊃Xg		*/
		Pointer(struct _Object*)		next ;				/*	̂ւ̃|C^	*/
	}
		Object ;

/*	IuWFNg̈ʒu	*/
typedef struct	_ObjPos {
		Pointer(Object*)		obj ;		/*	IuWFNg	*/
		Matrix		mat ;		/*	ϊs		*/
		Pointer(struct _ObjPos*)		next ;		/*	ւ̃|C^	*/
	}
		ObjPos ;

/*	Of[Vij	*/
typedef struct	_Grad {
		int		gradtype ;			/*	w肪Ȃ 0		*/
		Vector	vec ;				/*	xNg				*/
		int		colnum ;			/*	Of[V̐F	*/
		Color	col[MAXGRAD] ;		/*	F						*/
		Float	degree[MAXGRAD] ;	/*	px					*/
	}
		Grad ;

/*	  */
typedef struct	_Environ {
		Color	back ;				/*	w肪Ȃ 	*/
		int		star ;				/*	w肪Ȃ 0	*/
		Grad	grad ;
		Float	depth ;				/*	w肪Ȃ 0	*/
		Color	depthcol ;
		char	map[MAXWORD] ;		/*	w肪Ȃ ""	*/
	}
		Environ ;

/*	_̃f[^  */
typedef struct	_Eye {
		Matrix	mat ;		/*	ϊs				*/
		Float	dist ;		/*	XN[܂ł̋	*/
	}
		Eye ;

/*	̃f[^  */
typedef struct	_Light {		/*	Kvȃp[^ZbgB*/
		int		type ;			/*	̃^Cv	*/
		Color	col ;			/*	̐F		*/
		Float	dist ;			/*@			*/
		Vector	vec ;			/*@̌		*/
		Float	size ;			/*	̍L		*/
		Point	point ;			/*@̈ʒu		*/
		char	name[MAXWORD] ; /*			*/
	}
		Light ;

/*	t[  */
typedef struct	_Frame {
		Environ env ;				/*@				*/
		Eye		eye ;				/*	_				*/
		int		lightnum ;			/*	̐			*/
		Light	light[MAXLIGHT] ;	/*					*/
		Pointer(ObjPos*)	objpos ;			/*@IuWFNgʒu	*/
	}
		Frame ;

/*	ϐ  */
#ifndef SCANNER
	extern	int		warninglevel ;		/*	xx			*/
	extern	int		end_of_file ;		/*	GhIut@C	*/
	extern	FILE	*errfp ;			/*	G[o̓t@C	*/
	extern	Float	minscale ;			/*	ŏ̐			*/
/*	By Taka2	*/
	extern	void	(*interrupt)(void);		/*  荞݃[`	*/
/*	By Taka2	*/
	extern	void	(*errorexec)(int);		/*  G[[`	*/
#endif

	extern	int		virtualmode ;				/*  zL[h		*/
#if 0
#ifdef DJ
	#ifndef SCANNER
		extern	int		virtualmode ;				/*  zL[h		*/
	#endif
#else
	#ifdef	GCC
		register	int		virtualmode asm( "d7" );	/*  zL[h		*/
	#else
		#ifndef SCANNER
			extern	int		virtualmode ;				/*  zL[h		*/
		#endif
	#endif
#endif
#endif


/*	vg^Cv錾	*/
/*
	proto -e -f atrread.c objread.c objatr.c temp.c > temp
	proto -e -f framread.c matrix.c alloc.c virtual.c >> temp
*/

/*  atrread.c  */
extern	Pointer(Atr*)	atrread( char*, Pointer(Atr*) );

/*  objread.c  */
extern	Pointer(Object*)	objread( char*, Pointer(Object*) );

/*  objatr.c  */
extern	int		objatr( Pointer(Object*), Pointer(Atr*) );

/*  temp.c  */
extern	void	tempopen( char* );
extern	Pointer(Object*)	tempread( char*, Pointer(Object*) );
extern	void	tempclose( char* );

/*  framread.c  */
extern	int		frameopen( char* );
extern	void	frameclose( void );
extern	int		frameskip( void );
extern	Frame	*frameread( Pointer(Object*) );
#if 1 /* 1995.08.08 */
extern	Frame	*frameread2( int *, char *** );
#endif

#ifdef INLINE_MATRIX
#include "matrix.c"
#else
/*  matrix.c  */
	extern	void	m_print( Matrix );
	extern	void	m_unit( Matrix );
	extern	void	m_mov( Matrix, Vector );
	extern	void	m_rot( Matrix, int, Float );
	extern	void	m_scal( Matrix, Point );
	extern	void	m_vec( Matrix, Vector, Vector );
	extern	void	m_copy( Matrix, Matrix );
	extern	void	m_mult( Matrix, Matrix, Matrix );
	extern	void	vec_mult_mat( Vector*, Vector*, Matrix, int, int );
	extern	void	m_trans( Matrix, Matrix );
	extern	int		m_inv( Matrix, Matrix );
#endif
#ifdef INLINE_VECTOR
#include "vector.c"
#else
/*  vector.c  */
	extern	void	v_copy( Vector, Vector );
	extern	void	v_print( char*, Vector );
	extern	void	ftov( Vector, Float, Float, Float );
	extern	Float	v_length( Vector );
	extern	void	v_unit( Vector, Vector );
	extern	Float	s_pro( Vector, Vector );
	extern	void	v_pro( Vector, Vector, Vector );
	extern	void	v_mult( Vector, Vector, Vector );
	extern	void	v_add( Vector, Vector, Vector );
	extern	void	v_sub( Vector, Vector, Vector );
	extern	void	v_s_mult( Vector, Vector, Float );
	extern	void	c_copy( Color, Color );
	extern	void	vtoc( Color, Vector );
	extern	void	c_mult( Color, Color, Color );
	extern	void	c_add( Color, Color, Color );
	extern	void	c_s_mult( Color, Color, long );
#endif
/*  alloc.c  */
extern	void	meminit( long );
extern	void	*memalloc( int );
extern	void	*memaryalloc( int, int );
extern	char	*memmark( void );
extern	void	memrelease( char* );
extern	long	memsize( void );
extern	long	memgetsize(void);
extern	long	memallsize( void );
extern	void	*tempalloc( int );
extern	void	tempfree( void* );
extern	void	*temprealloc( void*, int );
extern	int		memcheck( void*, void*, int );

/*  virtual.c  */
#ifdef	VIRTUAL
	extern	void	virinit( char* );
	extern	Pointer	viralloc( int );
	extern	Pointer	viraryalloc( int, int );
	extern	Pointer	virarynext( Pointer, int );
	extern	Pointer	virmark( void );
	extern	void	virrelease( Pointer );
	extern	long	virsize( void );
	extern	int		virlock( void );
	extern	void	virunlock( int );
	extern	void	*virpointer( Pointer );
	extern	int		vircheck( Pointer, Pointer, int );
#endif

